/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-bwi-kr-execution-0.3.2-0precise-20150610-1542/srv/UpdateFluents.srv
 *
 */


#ifndef BWI_KR_EXECUTION_MESSAGE_UPDATEFLUENTSREQUEST_H
#define BWI_KR_EXECUTION_MESSAGE_UPDATEFLUENTSREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <bwi_kr_execution/AspFluent.h>

namespace bwi_kr_execution
{
template <class ContainerAllocator>
struct UpdateFluentsRequest_
{
  typedef UpdateFluentsRequest_<ContainerAllocator> Type;

  UpdateFluentsRequest_()
    : fluents()  {
    }
  UpdateFluentsRequest_(const ContainerAllocator& _alloc)
    : fluents(_alloc)  {
    }



   typedef std::vector< ::bwi_kr_execution::AspFluent_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::bwi_kr_execution::AspFluent_<ContainerAllocator> >::other >  _fluents_type;
  _fluents_type fluents;




  typedef boost::shared_ptr< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct UpdateFluentsRequest_

typedef ::bwi_kr_execution::UpdateFluentsRequest_<std::allocator<void> > UpdateFluentsRequest;

typedef boost::shared_ptr< ::bwi_kr_execution::UpdateFluentsRequest > UpdateFluentsRequestPtr;
typedef boost::shared_ptr< ::bwi_kr_execution::UpdateFluentsRequest const> UpdateFluentsRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace bwi_kr_execution

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'bwi_kr_execution': ['/tmp/buildd/ros-hydro-bwi-kr-execution-0.3.2-0precise-20150610-1542/msg', '/tmp/buildd/ros-hydro-bwi-kr-execution-0.3.2-0precise-20150610-1542/obj-x86_64-linux-gnu/devel/share/bwi_kr_execution/msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "1f4c26fc97494fb1cf77da318e7c1d52";
  }

  static const char* value(const ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x1f4c26fc97494fb1ULL;
  static const uint64_t static_value2 = 0xcf77da318e7c1d52ULL;
};

template<class ContainerAllocator>
struct DataType< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bwi_kr_execution/UpdateFluentsRequest";
  }

  static const char* value(const ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "AspFluent[] fluents\n\
\n\
================================================================================\n\
MSG: bwi_kr_execution/AspFluent\n\
string name\n\
string[] variables\n\
uint32 timeStep\n\
";
  }

  static const char* value(const ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.fluents);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct UpdateFluentsRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::bwi_kr_execution::UpdateFluentsRequest_<ContainerAllocator>& v)
  {
    s << indent << "fluents[]" << std::endl;
    for (size_t i = 0; i < v.fluents.size(); ++i)
    {
      s << indent << "  fluents[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::bwi_kr_execution::AspFluent_<ContainerAllocator> >::stream(s, indent + "    ", v.fluents[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // BWI_KR_EXECUTION_MESSAGE_UPDATEFLUENTSREQUEST_H
